package org.enhydra.barracuda.contrib.dbroggisch.display;

import java.util.*;
import java.lang.reflect.*;
import org.apache.log4j.*;

public class ReflectionMapper {
    private static Logger logger = Logger.getLogger(ReflectionMapper.class.getName());
	static Map s_getters = new HashMap();

	private static class Getter {
		public Method method;
		public String name;
	}

	private static void createGetters(Class obj) {
		try {
			List getters = new ArrayList();
			if(logger.isDebugEnabled()) {
				logger.debug("Class " + obj);
			}
			Method [] ms = obj.getMethods();
			for(int i = 1; i < ms.length; i++) {
				String name = ms[i].getName();
				if(logger.isDebugEnabled()) {
					logger.debug("processing method " + name);
				}
				if(name.startsWith("get")) {
					Getter g = new Getter();
					g.method = ms[i];
					g.name = name.substring(3).toUpperCase();
					getters.add(g);
					if(logger.isDebugEnabled()) {
						logger.debug("Added Getter with name " + g.name);
					}										
				}
			}
			s_getters.put(obj, getters);
		} catch(SecurityException ex) {
		}
	}

	private static synchronized List getGetters(Class klass) {
		if(!s_getters.containsKey(klass)) {
			createGetters(klass);
		}
		return (List)s_getters.get(klass);
	}

	public static List map(List objs) {
		ArrayList res = new ArrayList(objs.size());
		for(Iterator it = objs.iterator(); it.hasNext();) {
			res.add(map(it.next()));
		}
		return res;
	}

	public static LightweightTemplateModel map(Object obj) {
		return map(new HashMapModel(), obj);
	}

	public static LightweightTemplateModel map(LightweightTemplateModel model, Object obj) {
		if(obj == null || model == null)
			return model;

		List getters = getGetters(obj.getClass());


		for(Iterator it = getters.iterator(); it.hasNext();) {
			try {
				Getter g = (Getter)it.next();						
				Object value = g.method.invoke(obj, null);
				if(logger.isDebugEnabled()) {
					logger.debug("Value: " + value);
				}
				model.setItem(g.name, value);
			} catch(IllegalAccessException ex) {
				ex.printStackTrace();
			} catch(InvocationTargetException ex) {
				ex.printStackTrace();
			} 
		}
		return model;				
	}
}
