/*
 * $Id: PageDispatcherFactory.java,v 1.4 2003/05/17 21:56:20 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.page;

import org.enhydra.barracuda.core.event.DispatcherFactory;
import org.enhydra.barracuda.core.event.EventDispatcher;
import org.apache.log4j.Logger;


/**
 * A simple convenience class providing a ready-set dispatcher factory. The
 * event dispatcher returned in this case provides for thread safety when
 * using session pages.  See {@link PageEventDispatcher} for details.
 * 
 * <p>To use this class, return an instance of this factory in the 
 * {@link org.enhydra.barracuda.core.event.ApplicationGateway#getDispatcherFactory() AplicationGateway.getDispatcherFactory()} 
 * method.</p>
 * 
 * @author <a href="mailto:deets@web.de">Diez B. Roggisch</a>
 * @version 1.0
 */
public class PageDispatcherFactory implements DispatcherFactory {

    private static final Logger logger = Logger.getLogger(PageDispatcherFactory.class.getName());

    public EventDispatcher getInstance() {
        if (logger.isDebugEnabled()) logger.debug("Using custom event dispatcher " + PageEventDispatcher.class.getName());
        return new PageEventDispatcher();
    }

}
