/*
 * $Id: RenderPageEventGateway.java,v 1.1 2003/03/24 05:18:01 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.page;

import org.enhydra.barracuda.core.event.DefaultEventGateway;
import org.enhydra.barracuda.core.event.helper.EventConnectorFactory;
import org.apache.log4j.Logger;


/**
 * A simple convenience class providing a ready-set event gateway with the
 * basic necessities for rendering pages. Unless you are writing your own
 * custom rendering code for pages, an object of this class must be provided
 * in your application gateway via
 * <code>specifyEventGateways(new RenderPageEventGateway())</code> or via
 * inclusion in your assembly descriptor.  If you forget to do this, you will
 * find that none of your pages render.
 * 
 * @author <a href="mailto:deets@web.de">Diez B. Roggisch</a>
 * @version 1.0
 */
public class RenderPageEventGateway extends DefaultEventGateway {

    private static final Logger logger = Logger.getLogger(RenderPageEventGateway.class.getName());

    public RenderPageEventGateway() {
        specifyLocalEventInterests(new EventConnectorFactory(RenderPageHandler.class), RenderPage.class);
        if (logger.isInfoEnabled()) logger.info("specifyLocalEventInterests(new EventConnectorFactory(RenderPageHandler.class), RenderPage.class);");
    }

}
