/*
 * $Id: RenderPageHandler.java,v 1.8 2003/05/07 18:54:25 diezr Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.page;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.enhydra.barracuda.core.event.DefaultBaseEventListener;
import org.enhydra.barracuda.core.event.EventException;
import org.enhydra.barracuda.core.event.ViewEventContext;
import org.apache.log4j.Logger;


/** 
 * @author <a href="mailto:deets@web.de">Diez B. Roggisch</a>
 * @version 1.0
 */
public class RenderPageHandler extends DefaultBaseEventListener {

    private static final Logger logger = Logger.getLogger(RenderPageHandler.class.getName());

    public void handleViewEvent(ViewEventContext context) 
            throws EventException, ServletException, IOException {
        HttpServletRequest req = context.getRequest();
        HttpSession session = req.getSession(false);

        Page page = null;
        if (session != null) {
            page = (Page)session.getAttribute(PageFactory.PAGE_KEY);
        }
        if (page == null) {
            page = (Page)context.getState(PageFactory.PAGE_KEY);
        }

        if (page != null) {
            page.render(context);
            context.getEvent().setHandled(true);
        } else {
            logger.error("No page in session, no page in context, allow to fall through to error response event handlers");
        }
    }

}
