/*
 * $Id: DBRApplicationGateway.java,v 1.3 2003/04/16 17:01:21 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.examples.controller;

import java.io.File;
import java.io.IOException;
import javax.servlet.http.HttpServletRequest;
import org.enhydra.barracuda.core.event.ApplicationGateway;
import org.enhydra.barracuda.core.event.DispatcherFactory;
import org.enhydra.barracuda.core.event.RequestWrapper;
import org.enhydra.barracuda.core.helper.servlet.HttpServletRequestWrapper;
import org.enhydra.barracuda.contrib.dbroggisch.page.PageDispatcherFactory;
import org.enhydra.barracuda.contrib.dbroggisch.page.RenderPageEventGateway;
import org.apache.log4j.Logger;

import org.enhydra.barracuda.contrib.dbroggisch.examples.controller.servlets.MyMultipartRequest;


public class DBRApplicationGateway extends ApplicationGateway {

    private static final Logger logger = Logger.getLogger(DBRApplicationGateway.class.getName());

    public static boolean WRAPPER_INSTALLED = false;

    public void initializeLocal() {
        WRAPPER_INSTALLED = installWrapper();
        specifyEventGateways(new RenderPageEventGateway());

    }

    private  boolean installWrapper() {
        String destDir = null;
        File tempDir = (File)getServletConfig().getServletContext().getAttribute("javax.servlet.context.tempdir");
        // Only if we have write permission to that directory we install the wrapper.
        if(tempDir.canWrite()) {
            REQUEST_WRAPPER = new SampleRequestWrapper(tempDir.getAbsolutePath());
            return true;
        }
        return false;
    }

    public static class SampleRequestWrapper implements RequestWrapper {
        String _destDir;
        public SampleRequestWrapper(String destDir) {
            _destDir = destDir;
        }

        public HttpServletRequestWrapper wrap(HttpServletRequest req) {
            // If the request isn't multipart/mime, we'll get a IOException. Then we 
            // simply pass the request directly to the 
            // org.enhydra.barracuda.core.helper.servlet.HttpServletRequestWrapper
            try {
                return new HttpServletRequestWrapper(new MyMultipartRequest(req, _destDir));
            } catch(IOException ex) {
                return new HttpServletRequestWrapper(req);
            }
        }
    }

//    public DispatcherFactory getDispatcherFactory() {
//        if (logger.isDebugEnabled()) logger.debug("instantiating SessionTreeStateDispatcherFactory");
//        return new SessionTreeStateDispatcher.DispatcherFactory();
//    }

    public DispatcherFactory getDispatcherFactory() {
        return new PageDispatcherFactory();
    }

}
