/*
 * $Id: PrefixMappingHandler.java,v 1.1 2003/03/26 21:51:19 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.examples.controller.handlers;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import org.enhydra.barracuda.core.event.ControlEventContext;
import org.enhydra.barracuda.core.event.EventException;
import org.enhydra.barracuda.core.forms.ValidationException;
import org.enhydra.barracuda.contrib.dbroggisch.page.Page;
import org.enhydra.barracuda.contrib.dbroggisch.page.PageEventListener;
import org.apache.log4j.Logger;

import org.enhydra.barracuda.contrib.dbroggisch.examples.controller.events.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.model.forms.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.view.pages.*;


public class PrefixMappingHandler extends PageEventListener {

    private static final Logger logger = Logger.getLogger(PrefixMappingHandler.class.getName());

    public void handleControlEvent(ControlEventContext context, Page p)
            throws EventException, ServletException, IOException {
        HttpServletRequest request = context.getRequest();
        List maps = new ArrayList();
        ParentFormMap pfm = new ParentFormMap();
        PrefixmappingPage pmPage = (PrefixmappingPage)p;
        pmPage.setState(ExampleBasePage.PREFIXMAPPING);
        maps.add(pfm);

        if (ParentFormMap.MODEL_NAME.equals(request.getParameter("visited"))) {
            try {
                pfm.map(request).validate(true);
            } catch(ValidationException ex) {
                logger.error("Form Validation Exception", ex);
            }

            int cc = (pfm.getVal(ParentFormMap.CHILD_COUNT) != null ?
                  ((Integer)pfm.getVal(ParentFormMap.CHILD_COUNT)).intValue() : 0);

            if (context.getEvent() instanceof PrefixMappingAddChild) {
                cc++;
                pfm.getElement(ParentFormMap.CHILD_COUNT).setOrigVal("" + cc);
                          
            }

            for (int i = 0; i < cc; i++) {
                ChildFormMap cfm = new ChildFormMap();
                cfm.setPrefix("CFM" + i);
                maps.add(cfm);
                try {
                    cfm.map(request).validate(true);
                } catch(ValidationException ex) {
                    logger.error("Form Validation Exception", ex);
                }                   
            }
        }
        pmPage.setMaps(maps);
        context.getEvent().setHandled(true);
    }

}
