/*
 * $Id: RepopulationHandler.java,v 1.1 2003/03/26 21:51:19 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.examples.controller.handlers;

import java.io.IOException;
import java.util.Iterator;
import java.util.Map;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import org.enhydra.barracuda.core.event.ControlEventContext;
import org.enhydra.barracuda.core.event.EventException;
import org.enhydra.barracuda.core.forms.FormElement;
import org.enhydra.barracuda.core.forms.ValidationException;
import org.enhydra.barracuda.contrib.dbroggisch.page.Page;
import org.enhydra.barracuda.contrib.dbroggisch.page.PageEventListener;
import org.apache.log4j.Logger;

import org.enhydra.barracuda.contrib.dbroggisch.examples.model.forms.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.view.pages.*;


public class RepopulationHandler extends PageEventListener {

    private static final Logger logger = Logger.getLogger(RepopulationHandler.class.getName());

    public void handleControlEvent(ControlEventContext context, Page p)
            throws EventException, ServletException, IOException {
        HttpServletRequest request = context.getRequest();
        ExampleFormMap cfm = new ExampleFormMap();
        RepopulationPage rPage = (RepopulationPage)p;
        rPage.setState(ExampleBasePage.REPOPULATION);

        // We put the form map into the page
        // so it can act as template model for
        // the rendering process.
        rPage.setRFM(cfm);

        // The request is only mapped and validated if a special hidden parameter is present.
        // I usually call it "visited". Be careful to assign a unique name to it, or you might
        // expirience strange errors when the application event flow is routed to a different event 
        // handling form maps.
        if (ExampleFormMap.MODEL_NAME.equals(request.getParameter("visited"))) {
            try {
                // This is all you have to do - mapping and validation.
                cfm.map(request).validate(true);
                
                // Print all values the elements have.
                if (logger.isDebugEnabled()) {
                    Map els = cfm.getElements();

                    for (Iterator it = els.entrySet().iterator(); it.hasNext();) {
                        Map.Entry entry = (Map.Entry)it.next();
                        String name = (String)entry.getKey();
                        FormElement fel = (FormElement)entry.getValue();
                        logger.debug("Element " + name + ":");
                        Object val = fel.getVal();

                        if (val != null) {
                            logger.debug("Value class: " + val.getClass().getName());
                            logger.debug("Value: " + val);
                        } else {
                            logger.debug("Has a null-value");
                        }
                    }
                }
            } catch (ValidationException ex) {
                logger.error("Form Validation Exception", ex);
            }
        }
        context.getEvent().setHandled(true);
        //context.getQueue().addEvent(new RenderRepopulation());
    }

}
