/*
 * $Id: MyMultipartRequest.java,v 1.1 2003/03/26 21:51:19 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.examples.controller.servlets;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.security.Principal;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletInputStream;
import javax.servlet.ServletRequest;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import com.oreilly.servlet.MultipartRequest;


public class MyMultipartRequest extends MultipartRequest implements HttpServletRequest {
    HttpServletRequest _req;
    Map _pMap;
    public MyMultipartRequest(HttpServletRequest req, String destDir) 
        throws IOException
    {
        super(req, destDir);
        _req = req;
    }

    // Code for delegation of javax.servlet.http.HttpServletRequest methods to _req

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getMethod()
     */
    public String getMethod() {
        return _req.getMethod();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getAuthType()
     */
    public String getAuthType() {
        return _req.getAuthType();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getCookies()
     */
    public Cookie[] getCookies() {
        return _req.getCookies();
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getDateHeader(String)
     */
    public long getDateHeader(String param1) {
        return _req.getDateHeader(param1);
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getHeader(String)
     */
    public String getHeader(String param1) {
        return _req.getHeader(param1);
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getHeaders(String)
     */
    public Enumeration getHeaders(String param1) {
        return _req.getHeaders(param1);
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getHeaderNames()
     */
    public Enumeration getHeaderNames() {
        return _req.getHeaderNames();
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getIntHeader(String)
     */
    public int getIntHeader(String param1) {
        return _req.getIntHeader(param1);
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getPathInfo()
     */
    public String getPathInfo() {
        return _req.getPathInfo();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getPathTranslated()
     */
    public String getPathTranslated() {
        return _req.getPathTranslated();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getContextPath()
     */
    public String getContextPath() {
        return _req.getContextPath();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getQueryString()
     */
    public String getQueryString() {
        return _req.getQueryString();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getRemoteUser()
     */
    public String getRemoteUser() {
        return _req.getRemoteUser();
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#isUserInRole(String)
     */
    public boolean isUserInRole(String param1) {
        return _req.isUserInRole(param1);
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getUserPrincipal()
     */
    public Principal getUserPrincipal() {
        return _req.getUserPrincipal();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getRequestedSessionId()
     */
    public String getRequestedSessionId() {
        return _req.getRequestedSessionId();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getRequestURI()
     */
    public String getRequestURI() {
        return _req.getRequestURI();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getRequestURL()
     */
    public StringBuffer getRequestURL() {
        return _req.getRequestURL();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getServletPath()
     */
    public String getServletPath() {
        return _req.getServletPath();
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getSession(boolean)
     */
    public HttpSession getSession(boolean param1) {
        return _req.getSession(param1);
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#getSession()
     */
    public HttpSession getSession() {
        return _req.getSession();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#isRequestedSessionIdValid()
     */
    public boolean isRequestedSessionIdValid() {
        return _req.isRequestedSessionIdValid();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#isRequestedSessionIdFromCookie()
     */
    public boolean isRequestedSessionIdFromCookie() {
        return _req.isRequestedSessionIdFromCookie();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#isRequestedSessionIdFromURL()
     */
    public boolean isRequestedSessionIdFromURL() {
        return _req.isRequestedSessionIdFromURL();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.http.HttpServletRequest#isRequestedSessionIdFromUrl()
     */
    public boolean isRequestedSessionIdFromUrl() {
        return _req.isRequestedSessionIdFromUrl();
    }
    // Code for delegation of javax.servlet.ServletRequest methods to _req

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getCharacterEncoding()
     */
    public String getCharacterEncoding() {
        return _req.getCharacterEncoding();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getProtocol()
     */
    public String getProtocol() {
        return _req.getProtocol();
    }

    /**
     *
     * @return <description>
     * @exception java.io.IOException <description>
     * @see javax.servlet.ServletRequest#getInputStream()
     */
    public ServletInputStream getInputStream() throws IOException {
        return _req.getInputStream();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getContentLength()
     */
    public int getContentLength() {
        return _req.getContentLength();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getContentType()
     */
    public String getContentType() {
        return _req.getContentType();
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.ServletRequest#getAttribute(String)
     */
    public Object getAttribute(String param1) {
        return _req.getAttribute(param1);
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getAttributeNames()
     */
    public Enumeration getAttributeNames() {
        return _req.getAttributeNames();
    }

    /**
     *
     * @param param1 <description>
     * @exception java.io.UnsupportedEncodingException <description>
     * @see javax.servlet.ServletRequest#setCharacterEncoding(String)
     */
    public void setCharacterEncoding(String param1) throws UnsupportedEncodingException {
        _req.setCharacterEncoding(param1);
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.ServletRequest#getParameter(String)
     */
    public String getParameter(String param1) {
        return super.getParameter(param1);
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getParameterNames()
     */
    public Enumeration getParameterNames() {
        return super.getParameterNames();
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.ServletRequest#getParameterValues(String)
     */
    public String[] getParameterValues(String param1) {
        return super.getParameterValues(param1);
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getParameterMap()
     */
    public Map getParameterMap() {
        if(_pMap == null) {
            _pMap = new HashMap();
            for(Enumeration enum = super.getParameterNames(); enum.hasMoreElements();) {
                String name = (String)enum.nextElement();
                _pMap.put(name, super.getParameter(name));
            }
        }
        return _pMap;
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getScheme()
     */
    public String getScheme() {
        return _req.getScheme();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getServerName()
     */
    public String getServerName() {
        return _req.getServerName();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getServerPort()
     */
    public int getServerPort() {
        return _req.getServerPort();
    }

    /**
     *
     * @return <description>
     * @exception java.io.IOException <description>
     * @see javax.servlet.ServletRequest#getReader()
     */
    public BufferedReader getReader() throws IOException {
        return _req.getReader();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getRemoteAddr()
     */
    public String getRemoteAddr() {
        return _req.getRemoteAddr();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getRemoteHost()
     */
    public String getRemoteHost() {
        return _req.getRemoteHost();
    }

    /**
     *
     * @param param1 <description>
     * @param param2 <description>
     * @see javax.servlet.ServletRequest#setAttribute(String, Object)
     */
    public void setAttribute(String param1, Object param2) {
        _req.setAttribute(param1, param2);
    }

    /**
     *
     * @param param1 <description>
     * @see javax.servlet.ServletRequest#removeAttribute(String)
     */
    public void removeAttribute(String param1) {
        _req.removeAttribute(param1);
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getLocale()
     */
    public Locale getLocale() {
        return _req.getLocale();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#getLocales()
     */
    public Enumeration getLocales() {
        return _req.getLocales();
    }

    /**
     *
     * @return <description>
     * @see javax.servlet.ServletRequest#isSecure()
     */
    public boolean isSecure() {
        return _req.isSecure();
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.ServletRequest#getRequestDispatcher(String)
     */
    public RequestDispatcher getRequestDispatcher(String param1) {
        return _req.getRequestDispatcher(param1);
    }

    /**
     *
     * @param param1 <description>
     * @return <description>
     * @see javax.servlet.ServletRequest#getRealPath(String)
     */
    public String getRealPath(String param1) {
        return _req.getRealPath(param1);
    }

}
