/*
 * $Id: FileUploadPage.java,v 1.1 2003/03/26 21:51:19 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.examples.view.pages;

import java.io.IOException;
import java.util.List;
import java.util.Locale;
import javax.servlet.ServletException;
import org.w3c.dom.Document;
//import org.enhydra.xml.xmlc.XMLCStdFactory;
import org.enhydra.barracuda.core.comp.BComponent;
import org.enhydra.barracuda.core.comp.BList;
import org.enhydra.barracuda.core.comp.DefaultListModel;
import org.enhydra.barracuda.core.comp.DefaultView;
import org.enhydra.barracuda.core.comp.ViewContext;
import org.enhydra.barracuda.core.event.EventException;
import org.enhydra.barracuda.core.util.dom.DefaultDOMLoader;
import org.apache.log4j.Logger;

import org.enhydra.barracuda.contrib.dbroggisch.examples.view.xmlc.*;


public class FileUploadPage extends ExampleBasePage {

    private static final Logger logger = Logger.getLogger(FileUploadPage.class.getName());

    List _names;

    public void setNames(List names) {
        _names = names;
    }

    public void render(BComponent root, ViewContext vec, Document pDoc) 
            throws EventException, ServletException, IOException {
        super.render(root, vec, pDoc);
        FileUploadHTML doc = (FileUploadHTML)pDoc;
        BList fList = new BList();
        fList.setView(new DefaultView(doc.getElementFileNames()));
        DefaultListModel dlm = new DefaultListModel();
        dlm.addAll(_names);
        fList.setModel(dlm);
        root.addChild(fList);
    }

    public Document getDocument(Locale iLocale) {
        //return new XMLCStdFactory(null, null).create(FileUploadHTML.class);

        Document doc = null;
        //load the localized DOM template
        try {doc = DefaultDOMLoader.getGlobalInstance().getDOM(FileUploadHTML.class, iLocale);}
        catch (IOException ioe) {logger.fatal ("Fatal Error loading DOM template:", ioe);}
        return doc;
    }

}
