/*
 * $Id: PrefixmappingPage.java,v 1.1 2003/03/26 21:51:19 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.dbroggisch.examples.view.pages;

import java.io.IOException;
import java.util.List;
import java.util.Locale;
import javax.servlet.ServletException;
import org.w3c.dom.Document;
//import org.enhydra.xml.xmlc.XMLCStdFactory;
import org.enhydra.barracuda.core.comp.BAction;
import org.enhydra.barracuda.core.comp.BComponent;
import org.enhydra.barracuda.core.comp.BTemplate;
import org.enhydra.barracuda.core.comp.BText;
import org.enhydra.barracuda.core.comp.DefaultTemplateView;
import org.enhydra.barracuda.core.comp.ViewContext;
import org.enhydra.barracuda.core.event.EventException;
import org.enhydra.barracuda.core.util.dom.DefaultDOMLoader;
import org.enhydra.barracuda.contrib.dbroggisch.display.HashMapModel;
import org.enhydra.barracuda.contrib.dbroggisch.display.IterativeListModel;
import org.enhydra.barracuda.contrib.dbroggisch.repopulation.RepopulationFormMap;
import org.apache.log4j.Logger;

import org.enhydra.barracuda.contrib.dbroggisch.examples.controller.events.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.model.forms.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.view.xmlc.*;


public class PrefixmappingPage extends ExampleBasePage {

    private static final Logger logger = Logger.getLogger(PrefixmappingPage.class.getName());

    List _maps;

    public void setMaps(List maps) {
        _maps = maps;
    }

    public void render(BComponent root, ViewContext vec, Document pDoc)
            throws EventException, ServletException, IOException {
        super.render(root, vec, pDoc);
        Integer childCount = null;
        PrefixMappingHTML doc = (PrefixMappingHTML) pDoc;
        BTemplate mapComp = new BTemplate();

        mapComp.setView(new DefaultTemplateView(doc.getElementTestHook()));

        if(_maps.size() > 0) {
            // This is the parent form map
            RepopulationFormMap rfm = (RepopulationFormMap)_maps.remove(0);
            mapComp.addModel(rfm);
            childCount = (Integer)rfm.getVal(ParentFormMap.CHILD_COUNT);
        }

        IterativeListModel ilm = new IterativeListModel(ChildFormMap.MODEL_NAME, _maps) {
                public Object getItem(String key) {
                    return ((RepopulationFormMap)_current).getItem(key);
                }
            };

        mapComp.addModel(ilm);
        HashMapModel hmm = new HashMapModel();
        hmm.setName("ControlModel");
        hmm.setItem("SUBMIT", new BAction(new PrefixMapping()));
        hmm.setItem("ADD", new BAction(new PrefixMappingAddChild()));
        mapComp.addModel(hmm);

        HashMapModel foo = new HashMapModel();
        foo.setName("FooModel");
        foo.setItem(ParentFormMap.CHILD_COUNT, new BText(childCount == null ? "None" : 
                                                         childCount.intValue() == 0 ? "None" :
                                                         "" + childCount.intValue()));

        mapComp.addModel(foo);
        root.addChild(mapComp);
    }

    public Document getDocument(Locale iLocale) {
        //return new XMLCStdFactory(null, null).create(PrefixMappingHTML.class);

        Document doc = null;
        //load the localized DOM template
        try {doc = DefaultDOMLoader.getGlobalInstance().getDOM(PrefixMappingHTML.class, iLocale);}
        catch (IOException ioe) {logger.fatal ("Fatal Error loading DOM template:", ioe);}
        return doc;
    }

}
