package org.enhydra.barracuda.contrib.sam.data;

/** general exception class for all issues dealing with DataObjects
*/
public class DataObjectException extends Exception
{

	public static String DEFAULT_MESSAGE = null;

	public DataObjectException() 
	{ 
		super();
	}

	/* commented out due to a incompability to JDK 1.3 */
	/*public DataObjectException(Throwable t) 
	{
		super(t);
	}*/

	public DataObjectException(String s) 
	{
		super(s);
	}

	/* commented out due to a incompability to JDK 1.3 */
	/*public DataObjectException(String s, Throwable t)
	{
		super(s,t);
	}*/

	/** if the constructor was called with a non-null message, the default message is returned, 
  	* otherwise the constructor's message.*/
	public String getMessage() {
		String s = super.getMessage();
		if (s==null) {
			s = getDefaultMessage();
		}
		return s;
	}

	protected String getDefaultMessage() {
		return DEFAULT_MESSAGE;
	}
}

