/**
 * $Id: DataObjectGateway.java,v 1.2 2003/05/01 14:44:43 jacobk Exp $
 */
package org.enhydra.barracuda.contrib.sam.data;

import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.event.helper.*;
import org.apache.log4j.*;

/**
 * Event handlers (both Controller and View) for the
 * Main screen
 */
public abstract class DataObjectGateway extends DefaultEventGateway {
    
    //public constants
    protected static Logger logger = Logger.getLogger(DataObjectGateway.class.getName());
    
    protected abstract Class getDefaultHandler();
    protected abstract Class getDefaultEvent();
    protected abstract Class getSaveHandler();
    protected abstract Class getSaveEvent();
    protected abstract Class getDeleteHandler();
    protected abstract Class getDeleteEvent();
    protected abstract Class getNewHandler();
    protected abstract Class getNewEvent();
    protected abstract Class getListHandler();
    protected abstract Class getListEvent();
    protected abstract Class getRenderEvent();
    protected abstract Class getRenderHandler();
    
    
    
    public DataObjectGateway() {
        logger.debug("registering Handlers:");
        logger.debug("DefaultEvent: " + getDefaultEvent().getName());
        specifyLocalEventInterests(new EventConnectorFactory(getDefaultHandler()), getDefaultEvent());
        specifyLocalEventInterests(new EventConnectorFactory(getSaveHandler()), getSaveEvent());
        specifyLocalEventInterests(new EventConnectorFactory(getDeleteHandler()), getDeleteEvent());
        specifyLocalEventInterests(new EventConnectorFactory(getNewHandler()), getNewEvent());
        if (getListEvent() != null) {
				specifyLocalEventInterests(new EventConnectorFactory(getListHandler()), getListEvent());
			}
        specifyLocalEventInterests(new EventConnectorFactory(getRenderHandler()), getRenderEvent());
        //specifyLocalEventInterests(new EventConnectorFactory(getHandler()), Event);
    }
}
