package org.enhydra.barracuda.contrib.sam.data;

import java.lang.reflect.*;

import org.enhydra.barracuda.contrib.sam.data.*;
import org.enhydra.barracuda.core.event.*;
import org.apache.log4j.*;

public abstract class DefaultConfig implements Config {
    
    protected static Logger logger = Logger.getLogger(DefaultConfig.class.getName());
    
    protected Class viewEvent;
    protected String xmlFormName;
    protected String formName;
    protected String MAP = "MAP";
    protected String OID = "oid";
    
    public DefaultConfig(Class viewEvent, String xmlFormName, String formName) {
        this.viewEvent = viewEvent;
        this.xmlFormName = xmlFormName;
        this.formName = formName;
    }
    
    public ViewEvent getViewEvent() {
        try {
            Class[] args = new Class[0];
            Object[] param = new Object[0];
            Constructor c = viewEvent.getConstructor(args);
            return (ViewEvent)c.newInstance(param);
        } catch (Exception ex) {
            logger.error(ex.getMessage(), ex) ;
            return null;
        }
    }
    
    public String getXmlFormName() {
        return xmlFormName;
    }
    
    public String getFormName() {
        return formName;
    }
    
    public String getMapName() {
        return MAP;
    }
    
    public String getOidName() {
        return OID;
    }
    
    public abstract DataObject getDataObject(String oid) throws DataObjectException;
    
}
