/*
 * DBIterativeModel.java
 *
 * Created on 10. Oktober 2002, 15:45
 */

package org.enhydra.barracuda.contrib.sam.models;

import org.enhydra.barracuda.core.comp.*;
import org.apache.log4j.*;
import java.util.*;

/** iterates over a Map, uses the special keys "Key" and "Value" for returning key-value-pairs
 * @author Stefan Armbruster
 * @version $Id: IteratorModel.java,v 1.2 2003/03/03 15:27:12 jacobk Exp $
 */
public abstract class IteratorModel extends AbstractIterativeTemplateModel {
    
    protected static Logger logger = Logger.getLogger(IteratorModel.class.getName());
    
    /** data to iterate  */    
    /** name of the model */    
    protected String name;
	protected Iterator _iter;
	
		/** current element during iteration, might be casted to appropiate class */
	protected Object _current;

    /** initialize the model
     * @param name Name of the model
     * @param rs ResultSet to iterate
     */
    public IteratorModel(String name, Iterator iter) {
        _iter = iter;
        setName(name);
    }
    
    public IteratorModel(String name ) {
        _iter = null;
        setName(name);
    }
    
    /** get the name of the model
     * @return name of the model
     */    
    public String getName() {
        return name;
    }

	 public void setIterator(Iterator iter) {
		_iter = iter;
	 }
    
    /** set the name of the model
     * @param name name of the model
     */    
    public void setName(String name) {
        this.name = name;
    }

    /** 
     * 
     */    
    public boolean hasNext() {
		return _iter.hasNext();
    }
    
    /** empty implementation, does nothing. Only reason for being here is to fully
     * implement IterativeModel.
     */    
    public void loadNext() {
		_current = _iter.next();
    }
    
}
