/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site (http://www.enhydra.org/).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: TemplateModel.java,v 1.7 2003/03/07 20:19:19 christianc Exp $
 */
package org.enhydra.barracuda.core.comp;

import java.util.*;

import org.enhydra.barracuda.core.comp.model.*;

/**
 * This interface defines the methods needed to implement a 
 * TemplateModel.
 */
public interface TemplateModel extends Model, Contextual {
    public String getName();
//    public void resetModel();
    public boolean processDirective(TemplateDirective td);
//csc_030603.2_start - this method has been replaced by the version that    
//takes a TemplateDirective. The implementation in AbstractTemplateModel, 
//however, continues to call getItem(String key) - that method is just no 
//longer part of the interface - so existing code should continue to work.
//    public Object getItem(String key); 
    public Object getItem(TemplateDirective td);    
//csc_030603.2_end
//    public void addTemplateModelListener(TemplateModelListener l);
//    public void removeTemplateModelListener(TemplateModelListener l);
}

