/*
 * Copyright 2002 ATMReports.com. All Rights Reserved.
 *
 * This software is the proprietary information of ATMReports.com.
 * Use is subject to license terms.
 *
 * $Id:
 */
package org.enhydra.barracuda.testbed;

import junit.framework.*;
import org.apache.log4j.*;
import org.apache.log4j.xml.*;


/**
 * The base class from which all other Barracuda test classes should extend.
 * Will automatically configure log4j based on the settings in WEB-INF/log4j.xml
 */
public class DefaultTestCase extends TestCase {
    //common vars (customize for every test class)
    public static String testClass = DefaultTestCase.class.getName();
    public static Logger logger = Logger.getLogger("test."+testClass);

    //variables
    public final static String TEST_SUITE_USER = "TestSuiteUser";

    //-------------------- Basics --------------------------------
    /**
     * Public Constructor
     */
    public DefaultTestCase(String name) {
        super(name);
    }


    /**
     * Static initializer, for the first time a test case is accessed. The
     * basic purpose of this is to set up the default ObjectRepository to
     * match what we expect at runtime.
     */
    static {
        //manually configure the log4j stuff
        DOMConfigurator.configure("../WEB-INF/log4j.xml");
    }

}
